"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAccessibleColors = void 0;
const react_1 = __importDefault(require("react"));
const Provider_1 = require("../components/Provider");
function useAccessibleColors() {
    const { colorMode: colorModeContext, } = react_1.default.useContext(Provider_1.HooksContext);
    const toggleAccessibleColors = () => colorModeContext.setAccessibleColors(!colorModeContext.accessibleColors);
    return [
        colorModeContext.accessibleColors,
        colorModeContext.setAccessibleColors,
        toggleAccessibleColors,
    ];
}
exports.useAccessibleColors = useAccessibleColors;
