"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.modifyConfig = void 0;
const lodash_clonedeep_1 = __importDefault(require("lodash.clonedeep"));
// main modification function
function modifyConfig(config) {
    const tokens = (0, lodash_clonedeep_1.default)(config.tokens);
    modifyColor(tokens.colors);
    modifyGlobalVariants(tokens);
    tokens.aliases = (0, lodash_clonedeep_1.default)(config.aliases);
    return tokens;
}
exports.modifyConfig = modifyConfig;
// change architecture of colors
function modifyColor(obj) {
    for (const key in obj) {
        if (/\.\d+/.test(key)) {
            const colorAlias = key.split('.');
            const colorScheme = colorAlias[0];
            const shade = colorAlias.slice(1).join('.');
            if (!obj[colorScheme]) {
                obj[colorScheme] = {};
            }
            obj[colorScheme] = Object.assign(Object.assign({}, obj[colorScheme]), { [shade]: obj[key] });
            delete obj[key];
        }
    }
}
// modify global variants
function modifyGlobalVariants(obj) {
    for (const key in obj.globalStyle) {
        const globalVariant = key.split('.')[1];
        obj[globalVariant] = obj.globalStyle[key];
    }
    delete obj.globalStyle;
}
